#!/bin/bash
# Version 0.5
# Autor: Olivier Jankovsky & Justus Henckel
###### Constants
xld="/Applications/XLD/CLI/xld"
#xld="/Applications/xld"
maxfilenameSize="25"

clear
echo Welche Stimme soll ich verwenden?
Say " Welche Stimme soll ich verwenden?"
PS3="Ihre Auswahl? "
select AUSWAHL in $(say -v '?' | grep ${LANG%.*} | cut -d" " -f1) "DEMO (kurze Sprachausgabe)"
do
#!/bin/bash
case $AUSWAHL in
"DEMO (kurze Sprachausgabe)") 
for i in $(say -v '?' | grep ${LANG%.*} | cut -d" " -f1)
do
say -v $i "Ich heiße $i"
done
;;
*)
  Say -v $AUSWAHL --rate 190 "Stimme: " $AUSWAHL "wurde  ausgewählt!"
voice=$AUSWAHL
break ;;
esac
done


echo
echo Bitte Wordliste auswählen
Say -v $AUSWAHL --rate 190 "Bitte Wordliste auswählen"
#cd /Users/JOJU/Modellbau/Sprachansage/
cd /Users/justushenckel/Modellbau/Sprachansage/Wortlisten/
#cd /Users/JOJU/Modellbau/Sprachansage/Wortlisten/
#cd /Users/saturn/DC_16_Audio_script/Neues_Script/txt2dc16wav/
select WORDLIST in $(find *.wordlist)
do
wordlist=$WORDLIST
 Say -v $voice --rate 190  "Sprachausgabe für ${wordlist%.*} wird erstellt. Es werden vorraussichtlich $(cat $WORDLIST | wc -l) Dateien erstellt."
 
break
done

folder=${wordlist%.*}
count=0

while [ -d $folder.$count ] 
do
count=$(( $count +1 ))
done

   Say -v $voice --rate 190 "Die Dateien werden im Verzeichniss: $folder PUNKT $count erstellt"

exportfolder=$folder.$count

mkdir $exportfolder

echo "Lese die Datei $wordlist ein ..."

OLDIFS=$IFS
IFS=";"
exec 3>&0
exec 0< "$wordlist"
while read id wavname txt2speek rate
    do
    trFilename=$(tr -cd '[a-zA-Z0-9_ ]' <<<"$wavname")
    sedFilename=$(sed -e "s/\(.\{$maxfilenameSize\}\).*/\1/" <<<"$trFilename")
    echo -n $wavname $sedFilename $rate
    echo -n $exportfolder
    say -v $voice -r $rate -o ${exportfolder}/${sedFilename} $txt2speek
    $xld -f wav -o ${exportfolder}/${sedFilename}.wav ${exportfolder}/${sedFilename}.aiff >/dev/null 2>&1
    rm ${exportfolder}/${sedFilename}.aiff 
    done
exec 0>&3
IFS=$OLDIFS

numresult=$(ls -l $exportfolder/*.wav | wc -l)

cat > ${exportfolder}/@Info.txt << EOF
$(sw_vers)
Stimme: ${voice}
Wortliste: ${wordlist##*/}
erstellt am: $(date)
Datein erstellt : $numresult
Datein word-list: $(cat $WORDLIST | wc -l)
EOF
cp $wordlist ${exportfolder}


if [ $numresult -eq $(cat $WORDLIST | wc -l)  ]
then
say -v $voice --rate 190 "Die Dateien wurden erfolgreich erstellt."
exit 0
else 
say -v $voice --rate 190 "Achtung es wurden $numresult Dateien erzeugt. In der Wortliste: $wordlist gab es aber insgesamt $(cat $WORDLIST | wc -l) Einträge"
exit 1
fi

